import requests, datetime, os



def download_backup(backup_url: str, file_path: str):
    r = requests.get(backup_url, stream = True) 
  
    with open(file_path,"wb") as pdf: 
        for chunk in r.iter_content(chunk_size=1024): 
  
            if chunk: 
               pdf.write(chunk) 


def create_dirs_and_download(backup_url: str, date: datetime.datetime, base_path: str) -> str:
    year = str(date.year)
    month = str(date.month)
    day = str(date.day)
    
    if not os.path.exists(f"{base_path}/{year}"):
        os.makedirs(f"{base_path}/{year}")

    if not os.path.exists(f"{base_path}/{year}/{month}"):
        os.makedirs(f"{base_path}/{year}/{month}")

    save_path = f"{base_path}/{year}/{month}/{year}_{month}_{day}.tar.gz"

    print(save_path)

    download_backup(backup_url=backup_url, backup_path=save_path)

    return f"{year}/{month}/{year}_{month}_{day}.tar.gz"